package com.logicbig.example;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.container.AsyncResponse;
import javax.ws.rs.container.Suspended;
import javax.ws.rs.container.TimeoutHandler;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

@Path("/orders")
public class OrderResource {
    @GET
    public void getAllOrders(@Suspended final AsyncResponse ar) {
        ExecutorService es = Executors.newSingleThreadExecutor();

        ar.setTimeoutHandler(new TimeoutHandler() {
            @Override
            public void handleTimeout(AsyncResponse asyncResponse) {
                asyncResponse.resume("Processing timeout.");
                es.shutdown();
            }
        });

        ar.setTimeout(2, TimeUnit.SECONDS);
        es.submit(() -> {
            try {
                //Simulating a long running process
                Thread.sleep(4000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            ar.resume("all orders data....");
            es.shutdown();
        });
    }
}